DECLARE SUB exec86 (BYVAL execloops AS LONG)
DECLARE SUB DiskHandler ()
DECLARE SUB InsertDisk (BYVAL DriveNum AS LONG, DiskFileName AS STRING)
DECLARE SUB finddrivecount ()
DECLARE SUB ReadDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
DECLARE SUB WriteDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
TYPE typeDrive
    Cylinders AS LONG
    Sectors AS LONG
    Heads AS LONG
    Inserted AS INTEGER
END TYPE
TYPE RegTypeX
     ax    AS INTEGER
     bx    AS INTEGER
     cx    AS INTEGER
     dx    AS INTEGER
     bp    AS INTEGER
     si    AS INTEGER
     di    AS INTEGER
     flags AS INTEGER
     ds    AS INTEGER
     es    AS INTEGER
END TYPE

DIM SHARED Disk(&H83) AS typeDrive
DIM SHARED SectorBuffer AS STRING * 512
DECLARE SUB doirq (BYVAL irqnum AS LONG)
DECLARE SUB reset86 ()
DECLARE FUNCTION read86& (BYVAL addr32 AS LONG)
DECLARE SUB write86 (BYVAL addr32 AS LONG, BYVAL value AS LONG)
DECLARE SUB push (BYVAL pushval AS LONG)
DECLARE FUNCTION pop& ()
DECLARE FUNCTION makeflagsword& ()
DECLARE SUB decodeflagsword (BYVAL value AS LONG)
DECLARE FUNCTION signext& (BYVAL value AS INTEGER)
DECLARE FUNCTION readrm16& (BYVAL rmval AS INTEGER)
DECLARE FUNCTION readrm8& (BYVAL rmval AS INTEGER)
DECLARE SUB intcall86 (BYVAL intnum AS INTEGER)
DECLARE SUB flagszp8 (BYVAL value AS LONG)
DECLARE SUB flagszp16 (BYVAL value AS LONG)
DECLARE SUB flaglog8 (BYVAL value AS LONG)
DECLARE SUB flaglog16 (BYVAL value AS LONG)
DECLARE SUB flagadc8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagadc16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagadd8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagadd16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagsbb8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagsbb16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DECLARE SUB flagsub8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB flagsub16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DECLARE SUB opgrp1 (word&)
DECLARE FUNCTION opgrp28& (BYVAL cnt AS LONG)
DECLARE FUNCTION opgrp216& (BYVAL cnt AS LONG)
DECLARE SUB opdiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opdiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opidiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opidiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
DECLARE SUB opgrp3 (BYVAL word&)
DECLARE SUB opgrp5 ()
DECLARE FUNCTION in8259& (BYVAL portnum AS LONG)
DECLARE SUB out8259 (BYVAL portnum AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION nextintr& ()
DECLARE SUB opadc8 ()
DECLARE SUB opadc16 ()
DECLARE SUB opadd8 ()
DECLARE SUB opadd16 ()
DECLARE SUB opand8 ()
DECLARE SUB opand16 ()
DECLARE SUB opor8 ()
DECLARE SUB opor16 ()
DECLARE SUB opxor8 ()
DECLARE SUB opxor16 ()
DECLARE SUB optest8 ()
DECLARE SUB optest16 ()
DECLARE SUB opsub8 ()
DECLARE SUB opsub16 ()
DECLARE SUB opsbb8 ()
DECLARE SUB opsbb16 ()
DECLARE SUB opcmp8 ()
DECLARE SUB opcmp16 ()
DECLARE SUB portout (BYVAL portval AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION portin& (BYVAL portval AS LONG)
DECLARE SUB LoadBinary (MemAddr AS LONG, FileName AS STRING, Writable AS ANY)
DECLARE SUB StepIP (BYVAL stepcount AS LONG)
DECLARE SUB writerm16 (BYVAL rmval AS LONG, BYVAL value AS LONG)
DECLARE SUB writerm8 (BYVAL rmval AS LONG, BYVAL value AS LONG)
DECLARE SUB putreg16 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE SUB putreg8 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE SUB modregrm ()
DECLARE SUB putsegreg (BYVAL regnum AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION getmem8& (BYVAL segment AS LONG, BYVAL offset AS LONG)
DECLARE FUNCTION getmem16& (BYVAL segment AS LONG, BYVAL offset AS LONG)
DECLARE SUB putmem8 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
DECLARE SUB putmem16 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
DECLARE FUNCTION getreg16& (BYVAL regnum AS INTEGER)
DECLARE FUNCTION getreg8& (BYVAL regnum AS INTEGER)
DECLARE FUNCTION getsegreg& (BYVAL regnum AS INTEGER)
DECLARE SUB getea (rmval&)
DECLARE FUNCTION shl& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
DECLARE FUNCTION shr& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
DECLARE FUNCTION hexpad$ (BYVAL hexvalue AS LONG, BYVAL padsize AS LONG)
DEFLNG A-Z

COMMON SHARED running, debugmode AS INTEGER
DIM SHARED BIOS(8192) AS INTEGER
DIM SHARED VBIOS(0 TO 31) AS INTEGER
DIM SHARED Parity(255) AS INTEGER
DIM SHARED TraceLog AS INTEGER

COMMON SHARED tempea, ea AS LONG
COMMON SHARED regah, regal, regbh, regbl, regch, regcl, regdh, regdl, opcode, segoverride, hltstate AS LONG
COMMON SHARED savecs, saveip, regsp, regbp, regsi, regdi, regcs, regds, regss, reges, ip, useseg AS LONG
COMMON SHARED cf, pf, af, zf, sf, tf, ifl, df, of, mode, reg, rm AS LONG
COMMON SHARED oper1, oper2, res16, disp16, temp16, val16 AS LONG
COMMON SHARED oper1b, oper2b, res8, disp8, temp8, val8 AS LONG
COMMON SHARED temp1, temp2, temp3, temp4, temp5, hdcount, vidmode AS LONG
COMMON SHARED temp32 AS LONG
COMMON SHARED result AS LONG
COMMON SHARED totalexec AS LONG
COMMON SHARED regax AS LONG
COMMON SHARED regcx AS LONG
COMMON SHARED regdx AS LONG
COMMON SHARED regbx AS LONG
DIM SHARED KeyBuffer(16)   AS INTEGER
DIM SHARED KeyBufferPos AS LONG
DIM SHARED cursx, cursy AS LONG
DIM SHARED CRTC(255) AS LONG

DIM SHARED portram(4096) AS INTEGER
DIM SHARED cgagfx, mode13h, latchpal, latchreadpal, latchrgb, latchreadrgb, tempr, tempg, tempb, statedac, cols, rows AS LONG
DIM SHARED PaletteVGA(0 TO 255) AS LONG
DIM SHARED speakerenabled AS INTEGER
TYPE pictype
    imr AS LONG
    irr AS LONG
    isr AS LONG
    icwstep AS LONG
    icw(4) AS LONG
    intoffset AS LONG
    priority AS LONG
    autoeoi AS LONG
    readmode AS LONG
    enabled AS LONG
END TYPE

COMMON SHARED i8259 AS pictype
COMMON SHARED keyboardwaitack AS INTEGER
DIM SHARED keyevent AS INTEGER
DIM SHARED keypress AS STRING
DIM SHARED bootdrive AS INTEGER
DIM SHARED int9 AS STRING * 64
DIM SHARED ramlimit AS LONG

biosfile$ = "PCXTBIOS.BIN"
vgabiosfile$ = "VIDEOROM.BIN"
ramlimit = 256& * 1024&
PRINT "QB8086 v0.14.3.28 (c)2014 Mike Chambers"
PRINT "An 8086 PC emulator written entirely in QuickBASIC."
PRINT
ON ERROR RESUME NEXT
OPEN "qb8086.ini" FOR INPUT AS #1
IF ERR <> 0 THEN
  PRINT "QB8086.INI configuration file not found!"
END IF
DO UNTIL EOF(1)
  INPUT #1, directive$
  SELECT CASE LCASE$(directive$)
    CASE "fd0"
      LINE INPUT #1, a$
      PRINT "Floppy 0 image: " + a$;
      InsertDisk 0, a$
      IF Disk(0).Inserted = 0 THEN
	PRINT " (error loading!)"
	END
      END IF
      kbdisk = (Disk(0).Cylinders * Disk(0).Sectors * Disk(0).Heads * 512&) \ 1024&
      PRINT " (" + MID$(STR$(kbdisk), 2) + " KB)"
    CASE "fd1"
      LINE INPUT #1, a$
      PRINT "Floppy 1 image: " + a$;
      InsertDisk 1, a$
      IF Disk(1).Inserted = 0 THEN
	PRINT " (error loading!)"
	END
      END IF
      kbdisk = (Disk(1).Cylinders * Disk(1).Sectors * Disk(1).Heads * 512&) \ 1024&
      PRINT " (" + MID$(STR$(kbdisk), 2) + " KB)"
    CASE "hd0"
      LINE INPUT #1, a$
      PRINT "Hard disk 0 image: " + a$;
      InsertDisk &H80, a$
      IF Disk(&H80).Inserted = 0 THEN
	PRINT " (error loading!)"
	END
      END IF
      kbdisk = (Disk(&H80).Cylinders * Disk(&H80).Sectors * Disk(&H80).Heads * 512&) \ 1048576
      PRINT " (" + MID$(STR$(kbdisk), 2) + " MB)"
    CASE "hd1"
      LINE INPUT #1, a$
      PRINT "Hard disk 1 image: " + a$;
      InsertDisk &H81, a$
      IF Disk(&H81).Inserted = 0 THEN
	PRINT " (error loading!)"
	END
      END IF
      kbdisk = (Disk(&H81).Cylinders * Disk(&H81).Sectors * Disk(&H81).Heads * 512&) \ 1048576
      PRINT " (" + MID$(STR$(kbdisk), 2) + " MB)"
    CASE "boot"
      LINE INPUT #1, a$
      SELECT CASE LCASE$(a$)
	CASE "fd0"
	  bootdrive = 0
	CASE "fd1"
	  bootdrive = 1
	CASE "hd0"
	  bootdrive = &H80
	CASE ELSE
	  PRINT "Invalid boot drive: " + a$
	  END
      END SELECT
      PRINT "Boot drive: " + a$
    CASE "bios"
      LINE INPUT #1, biosfile$
    CASE "vgabios"
      LINE INPUT #1, vgabiosfile$
      PRINT "VGA BIOS: " + vgabiosfile$
    CASE "mem"
      INPUT #1, ramlimit
      IF ramlimit < 368 THEN ramlimit = 368
      IF ramlimit > 640 THEN ramlimit = 640
      ramlimit = (ramlimit \ 16&) * 16& 'BIOS checks RAM in 16 KB increments
      ramlimit = ramlimit * 1024&
  END SELECT
LOOP
CLOSE #1
swapsize = (ramlimit \ 1024&) - 368
IF swapsize < 0 THEN swapsize = 0
PRINT "Memory size:" + STR$(ramlimit \ 1024&) + " KB (" + MID$(STR$(swapsize), 2) + " KB as disk swap)"
DIM SHARED swapcur AS INTEGER
DIM SHARED swapram AS STRING * 1024
swapcur = -1
IF ramlimit > 368& * 1024& THEN
  PRINT "Preparing disk swap file... ";
  OPEN "SWAPRAM.DAT" FOR BINARY AS #2
  FOR n = 1 TO swapsize
    a$ = SPACE$(1024)
    PUT #2, , a$
  NEXT n
  PRINT "OK"
END IF

'int9 = CHR$(&H50) + CHR$(&HC7) + CHR$(&H6) + MKI$(VARPTR(keyevent)) + CHR$(&H1) + CHR$(&H0) + CHR$(&HB0) + CHR$(&H20) + CHR$(&HE6) + CHR$(&H20) + CHR$(&H58) + CHR$(&HCF)
temp9$ = CHR$(&H50) + CHR$(&H1E) + CHR$(&HB8) + MKI$(VARSEG(keyevent)) + CHR$(&H8E) + CHR$(&HD8)
temp9$ = temp9$ + CHR$(&HC7) + CHR$(&H6) + MKI$(VARPTR(keyevent)) + CHR$(&H1) + CHR$(&H0) + CHR$(&HB0) + CHR$(&H20) + CHR$(&HE6) + CHR$(&H20) + CHR$(&H1F) + CHR$(&H58) + CHR$(&HCF)

DEF SEG = VARSEG(int9)
FOR n = 1 TO LEN(temp9$)
  POKE VARPTR(int9) + n - 1, ASC(MID$(temp9$, n, 1))
NEXT n

DIM SHARED ramseg(0 TO 367) AS INTEGER
DIM SHARED inregs AS RegTypeX, outregs AS RegTypeX
DIM old9seg AS INTEGER, old9off AS INTEGER
heap = SETMEM(-1024& * 408) 'have QB release 408 KB off the heap so we can use it
FOR n = 0 TO 367 'allocate 368 KB of main emulator RAM in 1 KB chunks
inregs.ax = &H4800
inregs.bx = 64
CALL interruptx(&H21, inregs, outregs)
IF (outregs.flags AND 1) = 1 THEN
  PRINT "Error allocating memory!"
  END
END IF
ramseg(n) = outregs.ax
'PRINT "Allocated RAM at segment " + HEX$(ramseg(n)) + "h"
NEXT n

FOR n = 0 TO 31 'allocate 32 KB of RAM for video BIOS in 1 KB chunks
inregs.ax = &H4800
inregs.bx = 64
CALL interruptx(&H21, inregs, outregs)
IF (outregs.flags AND 1) = 1 THEN
  PRINT "Error allocating memory!"
  END
END IF
VBIOS(n) = outregs.ax
'PRINT "Allocated RAM at segment " + HEX$(ramseg(n)) + "h"
NEXT n

PRINT
PRINT "F11 will toggle status display update, F12 will exit emulator."
PRINT "Press any key to begin emulation..."

inregs.ax = &H3509
CALL interruptx(&H21, inregs, outregs)
old9seg = outregs.es
old9off = outregs.bx
inregs.ax = &H2509
inregs.ds = VARSEG(int9)
inregs.dx = VARPTR(int9)
CALL interruptx(&H21, inregs, outregs)
DO
  IF keyevent = 1 THEN
    keyevent = 0
    scancode = INP(&H60)
    kbstatus = INP(&H61)
    OUT &H61, kbstatus OR &H80
    IF (scancode AND &H80) = 0 THEN EXIT DO
  END IF
LOOP

CLS

OPEN biosfile$ FOR BINARY AS #1
a$ = SPACE$(1)
FOR n = 0 TO 8191
  GET #1, , a$
  BIOS(n) = ASC(a$)
NEXT n
CLOSE #1

OPEN vgabiosfile$ FOR BINARY AS #1
FOR n = 0 TO 31
  a$ = SPACE$(1024)
  GET #1, , a$
  FOR i = 0 TO 1023
    DEF SEG = VBIOS(n)
    POKE i, ASC(MID$(a$, i + 1, 1))
  NEXT i
NEXT n
CLOSE #1

'OPEN "video.txt" FOR OUTPUT AS #3

cols = 80
rows = 25
reset86
running = 1
DO
  exec86 500
  IF keyevent = 1 THEN
    keyevent = 0
    scancode = INP(&H60)
    kbstatus = INP(&H61)
    OUT &H61, kbstatus OR &H80
    'PRINT "Scancode = " + HEX$(scancode) + "h"
    SELECT CASE scancode
      CASE &HD8 'D8h is scancode for releasing F12 (quit emulator)
	EXIT DO
      CASE &HD7 'F11 toggles status display update
	IF showcsip = 1 THEN showcsip = 0 ELSE showcsip = 1
      CASE &H58, &H57 'ignore initial F11/F12 press
      CASE ELSE
	portram(&H60) = scancode
	portram(&H61) = kbstatus
	doirq 1
    END SELECT
  END IF
  exec86 500
  IF showcsip = 1 THEN
    disp$ = RIGHT$("000" + HEX$(regcs), 4) + ":" + RIGHT$("000" + HEX$(ip), 4) + STR$(totalexec)
    LOCATE 1, cols - LEN(disp$)
    PRINT disp$;
    IF cursy >= rows THEN cursy = rows - 1
    IF cursx >= cols THEN cursx = cols - 1
    LOCATE cursy + 1, cursx + 1, 1
  END IF
  doirq 0
LOOP
LOCATE 25, 1
inregs.ax = &H2509
inregs.ds = old9seg
inregs.dx = old9off
CALL interruptx(&H21, inregs, outregs)

SUB decodeflagsword (BYVAL value AS LONG)
cf = value AND 1
IF (value AND 4) THEN pf = 1 ELSE pf = 0
IF (value AND 16) THEN af = 1 ELSE af = 0
IF (value AND 64) THEN zf = 1 ELSE zf = 0
IF (value AND 128) THEN sf = 1 ELSE sf = 0
IF (value AND 256) THEN tf = 1 ELSE tf = 0
IF (value AND 512) THEN ifl = 1 ELSE ifl = 0
IF (value AND 1024) THEN df = 1 ELSE df = 0
IF (value AND 2048) THEN of = 1 ELSE of = 0
END SUB

SUB DiskHandler
SELECT CASE regah
    CASE 0 'reset disk system
	regah = 0: cf = 0 'useless function in an emulator. say successful and return.

    CASE 2 'read sector(s) into memory
	'MsgBox Hex$(es * 16 + getreg16(bx)) + vbCrLf + Hex$(es) + ":" + Hex$(getreg16(bx))
	ReadDisk regdl, reges, getreg16(regbx), regch + (regcl \ 64) * 256, (regcl AND 63), regdh, regal

    CASE 3 'write sector(s) from memory
	'MsgBox Hex$(es * 16 + getreg16(bx)) + vbCrLf + Hex$(es) + ":" + Hex$(getreg16(bx))
	WriteDisk regdl, reges, getreg16(regbx), regch + (regcl \ 64) * 256, regcl AND 63, regdh, regal

    CASE 8 'get drive parameters
	IF Disk(regdl).Inserted = 1 THEN
	    cf = 0: regah = 0
	    regch = Disk(regdl).Cylinders - 1
	    regcl = (Disk(regdl).Sectors AND 63) + (Disk(regdl).Cylinders \ 256) * 64
	    regdh = Disk(regdl).Heads - 1
	    IF regdl < &H80& THEN regbl = 4: regdl = 2 ELSE regdl = hdcount
	ELSE
	    cf = 1: regah = 4
	END IF

    CASE ELSE
	cf = 1
	'MsgBox "Unhandled interrupt 13h (disk services) function!" + vbCrLf + "AX: " + Hex$(getreg16(regax)) + vbCrLf + "DL: " + Hex$(regdl)
'        MsgBox Hex$(getreg16(bx))
END SELECT
END SUB

SUB doirq (BYVAL irqnum AS LONG)
    i8259.irr = i8259.irr OR shl(1, irqnum)
    IF irqnum = 1 THEN
	keyboardwaitack = 1
    END IF
END SUB

SUB EjectDisk (BYVAL DriveNum AS LONG)
Disk(DriveNum).Inserted = 0
'Disk(DriveNum).DiskFile = ""
CLOSE DriveNum + 5
finddrivecount
END SUB

SUB finddrivecount
hdcount = 0
FOR n = &H80& TO &H83&
    IF Disk(n).Inserted = 1 THEN hdcount = hdcount + 1
NEXT n
END SUB

SUB flagadc16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DIM dst AS LONG
v1 = v1 AND &HFFFF&
v2 = v2 AND &HFFFF&
v3 = v3 AND &HFFFF&
dst = v1 + v2 + v3
flagszp16 (dst)
IF (dst AND &HFFFF0000) THEN cf = 1 ELSE cf = 0
IF ((dst XOR v1) AND (dst XOR v2) AND &H8000&) = &H8000& THEN of = 1 ELSE of = 0
IF ((v1 XOR v2 XOR dst) AND &H10&) = &H10& THEN af = 1 ELSE af = 0
END SUB

SUB flagadc8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG)
DIM dst AS LONG
v1 = v1 AND &HFF&
v2 = v2 AND &HFF&
v3 = v3 AND &HFF&
dst = v1 + v2 + v3
flagszp8 (dst)
IF (dst AND &HFFFFF00) THEN cf = 1 ELSE cf = 0
IF ((dst XOR v1) AND (dst XOR v2) AND &H80&) = &H80& THEN of = 1 ELSE of = 0
IF ((v1 XOR v2 XOR dst) AND &H10&) = &H10& THEN af = 1 ELSE af = 0
END SUB

SUB flagadd16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DIM dst AS LONG
v1 = v1 AND &HFFFF&
v2 = v2 AND &HFFFF&
dst = v1 + v2
flagszp16 (dst)
IF (dst AND &HFFFF0000) THEN cf = 1 ELSE cf = 0
IF ((dst XOR v1) AND (dst XOR v2) AND &H8000&) = &H8000& THEN of = 1 ELSE of = 0
IF ((v1 XOR v2 XOR dst) AND &H10&) = &H10& THEN af = 1 ELSE af = 0
END SUB

SUB flagadd8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
DIM dst AS LONG
v1 = v1 AND &HFF&
v2 = v2 AND &HFF&
dst = v1 + v2
flagszp8 (dst)
IF (dst AND &HFFFFFF00) THEN cf = 1 ELSE cf = 0
IF ((dst XOR v1) AND (dst XOR v2) AND &H80&) = &H80& THEN of = 1 ELSE of = 0
IF ((v1 XOR v2 XOR dst) AND &H10&) = &H10& THEN af = 1 ELSE af = 0
END SUB

SUB flaglog16 (BYVAL value AS LONG)
flagszp16 (value)
cf = 0: of = 0
END SUB

SUB flaglog8 (BYVAL value AS LONG)
flagszp8 (value)
cf = 0: of = 0
END SUB

SUB flagsbb16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG) 'v3 is carry flag
	DIM dst AS LONG
	'v1 = v1 And &HFFFF&
	'v2 = v2 And &HFFFF&
	'v3 = v3 And &HFFFF&
	v2 = v2 + v3
	dst = v1 - v2
	flagszp16 (dst)
	IF v1 < v2 THEN cf = 1 ELSE cf = 0
	IF ((dst XOR v1) AND (v1 XOR v2) AND &H8000&) THEN of = 1 ELSE of = 0
	IF ((v1 XOR v2 XOR dst) AND &H10) THEN af = 1 ELSE af = 0
END SUB

SUB flagsbb8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG, BYVAL v3 AS LONG) 'v3 is carry flag
	DIM dst AS LONG
	'v1 = v1 And &HFF&
	'v2 = v2 And &HFF&
	'v3 = v3 And &HFF&
	v2 = v2 + v3
	dst = v1 - v2
	flagszp8 (dst)
	IF v1 < v2 THEN cf = 1 ELSE cf = 0
	IF ((dst XOR v1) AND (v1 XOR v2) AND &H80&) THEN of = 1 ELSE of = 0
   IF ((v1 XOR v2 XOR dst) AND &H10) THEN af = 1 ELSE af = 0
END SUB

SUB flagsub16 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
	DIM dst AS LONG
	'v1 = v1 And &HFFFF&
	'v2 = v2 And &HFFFF&
	dst = v1 - v2
	flagszp16 (dst)
	IF v1 < v2 THEN cf = 1 ELSE cf = 0
	IF ((dst XOR v1) AND (v1 XOR v2) AND &H8000&) THEN of = 1 ELSE of = 0
	IF ((v1 XOR v2 XOR dst) AND &H10) THEN af = 1 ELSE af = 0
END SUB

SUB flagsub8 (BYVAL v1 AS LONG, BYVAL v2 AS LONG)
	DIM dst AS LONG
	'v1 = v1 And &HFF&
	'v2 = v2 And &HFF&
	dst = v1 - v2
	flagszp8 (dst)
	IF v1 < v2 THEN cf = 1 ELSE cf = 0
	IF ((dst XOR v1) AND (v1 XOR v2) AND &H80&) THEN of = 1 ELSE of = 0
	IF ((v1 XOR v2 XOR dst) AND &H10) THEN af = 1 ELSE af = 0
END SUB

SUB flagszp16 (BYVAL value AS LONG)
value = value AND &HFFFF&
IF value = 0 THEN zf = 1 ELSE zf = 0
IF (value AND &H8000&) THEN sf = 1 ELSE sf = 0
pf = Parity(value AND 255)
END SUB

SUB flagszp8 (BYVAL value AS LONG)
value = value AND &HFF&
IF value = 0 THEN zf = 1 ELSE zf = 0
IF (value AND &H80&) THEN sf = 1 ELSE sf = 0
pf = Parity(value AND 255)
END SUB

SUB getea (rmval)
tempea = 0
SELECT CASE mode
    CASE 0
	SELECT CASE rmval
		CASE 0: tempea = ((regbh * 256&) OR regbl) + regsi
		CASE 1: tempea = ((regbh * 256&) OR regbl) + regdi
		CASE 2: tempea = regbp + regsi
		CASE 3: tempea = regbp + regdi
		CASE 4: tempea = regsi
		CASE 5: tempea = regdi
		CASE 6: tempea = disp16
		CASE 7: tempea = ((regbh * 256&) OR regbl)
	END SELECT
    CASE 1, 2
	SELECT CASE rmval
		CASE 0: tempea = ((regbh * 256&) OR regbl) + regsi + disp16
		CASE 1: tempea = ((regbh * 256&) OR regbl) + regdi + disp16
		CASE 2: tempea = regbp + regsi + disp16
		CASE 3: tempea = regbp + regdi + disp16
		CASE 4: tempea = regsi + disp16
		CASE 5: tempea = regdi + disp16
		CASE 6: tempea = regbp + disp16
		CASE 7: tempea = ((regbh * 256&) OR regbl) + disp16
	END SELECT
	CASE 3
		tempea = getreg16(rmval)
END SELECT
ea = (tempea AND &HFFFF&) + useseg * 16
ea = ea AND &HFFFFF
END SUB

FUNCTION getmem16& (BYVAL segment AS LONG, BYVAL offset AS LONG)
	getmem16 = read86(segment * 16 + offset) + read86(segment * 16 + offset + 1) * 256&
END FUNCTION

FUNCTION getmem8& (BYVAL segment AS LONG, BYVAL offset AS LONG)
	getmem8 = read86(segment * 16 + offset)
END FUNCTION

FUNCTION getreg16& (BYVAL regnum AS INTEGER)
SELECT CASE regnum
	CASE regax
	getreg16 = (regah AND 255) * 256& + (regal AND 255)
	CASE regcx
	getreg16 = (regch AND 255) * 256& + (regcl AND 255)
	CASE regdx
	getreg16 = (regdh AND 255) * 256& + (regdl AND 255)
	CASE regbx
	getreg16 = (regbh AND 255) * 256& + (regbl AND 255)
	CASE 4: getreg16 = regsp
    CASE 5: getreg16 = regbp
	CASE 6: getreg16 = regsi
	CASE 7: getreg16 = regdi
END SELECT
END FUNCTION

FUNCTION getreg8& (BYVAL regnum AS INTEGER)
SELECT CASE regnum
	CASE 0: getreg8 = regal
	CASE 1: getreg8 = regcl
	CASE 2: getreg8 = regdl
	CASE 3: getreg8 = regbl
	CASE 4: getreg8 = regah
	CASE 5: getreg8 = regch
	CASE 6: getreg8 = regdh
	CASE 7: getreg8 = regbh
END SELECT
END FUNCTION

FUNCTION getsegreg& (BYVAL regnum AS INTEGER)
SELECT CASE regnum
    CASE 0
	getsegreg = reges
    CASE 1
	getsegreg = regcs
    CASE 2
	getsegreg = regss
    CASE 3
	getsegreg = regds
END SELECT
END FUNCTION

FUNCTION hexpad$ (BYVAL hexvalue AS LONG, BYVAL padsize AS LONG)
hexpad = RIGHT$(STRING$(padsize, "0") + UCASE$(HEX$(hexvalue)), padsize)
END FUNCTION

FUNCTION in8259& (BYVAL portnum AS LONG)
    SELECT CASE (portnum AND 1)
	CASE 0
	    IF i8259.readmode = 0 THEN in8259 = i8259.irr ELSE in8259 = i8259.isr
	CASE 1
	    in8259 = i8259.imr
    END SELECT
END FUNCTION

SUB InsertDisk (BYVAL DriveNum AS LONG, DiskFileName AS STRING)
IF Disk(DriveNum).Inserted = 1 THEN CLOSE DriveNum + 5
Disk(DriveNum).Inserted = 1
'Disk(DriveNum).DiskFile = DiskFileName
ON ERROR RESUME NEXT
OPEN DiskFileName FOR INPUT AS DriveNum + 5
CLOSE DriveNum + 5
IF ERR <> 0 THEN
  Disk(DriveNum).Inserted = 0
  EXIT SUB
END IF
OPEN DiskFileName FOR BINARY AS DriveNum + 5
IF (DriveNum AND &H80) = &H80 THEN
    Disk(DriveNum).Sectors = 63: Disk(DriveNum).Heads = 16
    Disk(DriveNum).Cylinders = LOF(DriveNum + 5) \ (Disk(DriveNum).Sectors * Disk(DriveNum).Heads * 512)
ELSE
    Disk(DriveNum).Cylinders = 80: Disk(DriveNum).Sectors = 18: Disk(DriveNum).Heads = 2
    IF LOF(DriveNum + 5) <= 1228800 THEN Disk(DriveNum).Sectors = 15
    IF LOF(DriveNum + 5) <= 737280 THEN Disk(DriveNum).Sectors = 9
    IF LOF(DriveNum + 5) <= 368640 THEN Disk(DriveNum).Cylinders = 40: Disk(DriveNum).Sectors = 9
    IF LOF(DriveNum + 5) <= 327680 THEN Disk(DriveNum).Sectors = 8
END IF
finddrivecount
END SUB

SUB intcall86 (BYVAL intnum AS INTEGER)
       SELECT CASE intnum
	CASE &H10
	    SELECT CASE regah
	      CASE 0
		SELECT CASE regal AND &H7F
		  CASE 0, 1
		    SCREEN 0: WIDTH 40
		    cols = 40: rows = 25: mode13h = 0: cgagfx = 0
		  CASE 2, 6
		    SCREEN 2
		    cols = 80: rows = 25: mode13h = 0: cgagfx = 0
		  CASE 3
		    SCREEN 0: WIDTH 80
		    cols = 80: rows = 25: mode13h = 0: cgagfx = 0
		  CASE 4, 5
		    SCREEN 1
		    COLOR 0, 0
		    cols = 40: rows = 25: mode13h = 0: cgagfx = 1
		  CASE &H13
		    SCREEN 13
		    cols = 40: rows = 25: mode13h = 1: cgagfx = 0
		END SELECT
		'PRINT #3, "Screen mode " + HEX$(regal) + "h"
		'EXIT SUB
	      'CASE &H10 'set individual DAC register
	      '  'PRINT #3, "int 13h AH = 10h"
	      '  PaletteVGA(regbl AND 255) = (regdh AND 63) + (regch AND 63) * 256& + (regcl AND 63) * 65536
	      '  IF mode13h = 1 THEN PALETTE regbl AND 255, PaletteVGA(regbl AND 255)
	      '  'PRINT "Palette" + STR$(regbl AND 255) + " set"
	      '  EXIT SUB
	      'CASE &H12 'set block of DAC registers
	      '  'PRINT #3, "int 13h AH = 12h (pal " + STR$(getreg16(regbx)) + " to" + STR$((getreg16(regbx) + getreg16(regcx)))
	      '  temp32 = reges * 16& + getreg16(regdx)
	      '  FOR curpal = getreg16(regbx) TO (getreg16(regbx) + getreg16(regcx))
	      '    PaletteVGA(curpal AND 255) = (read86(temp32) AND 63) + (read86(temp32 + 1&) AND 63) * 256& + (read86(temp32 + 2&) AND 63) * 65536
	      '    IF mode13h = 1 THEN PALETTE curpal AND 255, PaletteVGA(curpal AND 255)
	      '    'PRINT "Palette" + STR$(curpal AND 255) + " set"
	      '    temp32 = temp32 + 3
	      '  NEXT curpal
	      '  EXIT SUB
	    END SELECT
	CASE &H13
	    DiskHandler
	    EXIT SUB
	CASE &H19
	    ReadDisk bootdrive, &H7C0&, 0, 0, 0, 0, 1
	    regcs = 0
	    ip = &H7C00&
	    regdl = bootdrive
	    EXIT SUB
       END SELECT

	push makeflagsword
	push regcs
	push ip
	regcs = getmem16(0, intnum * 4 + 2)
	ip = getmem16(0, intnum * 4)
	ifl = 0
	tf = 0
END SUB

SUB LoadBinary (MemAddr AS LONG, FileName AS STRING, Writable AS INTEGER)
	IF DIR$(FileName) = "" THEN EXIT SUB
	Handle = FREEFILE
	OPEN FileName FOR BINARY AS #Handle
	tmpdata$ = SPACE$(LOF(Handle))
	GET #Handle, , tmpdata$
	FOR n = 1 TO LEN(tmpdata$)
		'RAM(MemAddr + n - 1) = ASC(MID$(tmpdata$, n, 1))
		'IF Writable = 0 THEN ReadOnly(MemAddr + n - 1) = 1
	NEXT n
	CLOSE Handle
END SUB

FUNCTION makeflagsword&
makeflagsword = &HF002& + cf + (pf * 4) + (af * 16) + (zf * 64) + (sf * 128) + (tf * 256&) + (ifl * 512&) + (df * 1024&) + (of * 2048&)
END FUNCTION

SUB modregrm
	addrbyte = getmem8(regcs, ip): StepIP (1)
	mode = addrbyte \ 64
	reg = (addrbyte \ 8) AND 7
	rm = addrbyte AND 7
	SELECT CASE mode
		CASE 0
	    IF rm = 6 THEN disp16 = getmem16(regcs, ip): StepIP (2)
	    IF ((rm = 2) OR (rm = 3)) AND (segoverride = 0) THEN useseg = regss
		CASE 1
	    disp16 = signext(getmem8(regcs, ip)): StepIP (1)
	    IF ((rm = 2) OR (rm = 3) OR (rm = 6)) AND (segoverride = 0) THEN useseg = regss
		CASE 2
	    disp16 = getmem16(regcs, ip): StepIP (2)
	    IF ((rm = 2) OR (rm = 3) OR (rm = 6)) AND (segoverride = 0) THEN useseg = regss
		CASE ELSE
				disp8 = 0: disp16 = 0
	END SELECT
END SUB

FUNCTION nextintr&
    DIM i, tmpirr AS LONG
    tmpirr = i8259.irr AND (NOT i8259.imr)
    FOR i = 0 TO 7
	IF (shr(tmpirr, i) AND 1) THEN
	    i8259.irr = i8259.irr XOR shl(1, i)
	    i8259.isr = i8259.irr OR shl(1, i)
	    nextintr = i8259.icw(2) + i
	    EXIT FUNCTION
	END IF
    NEXT i
END FUNCTION

SUB opadc16
	res16 = (oper1 + oper2 + cf)
	flagadc16 oper1, oper2, cf
END SUB

SUB opadc8
	res8 = (oper1b + oper2b + cf)
	flagadc8 oper1b, oper2b, cf
END SUB

SUB opadd16
	res16 = (oper1 + oper2)
	flagadd16 oper1, oper2
END SUB

SUB opadd8
	res8 = (oper1b + oper2b)
	flagadd8 oper1b, oper2b
END SUB

SUB opand16
	res16 = (oper1 AND oper2)
	flaglog16 res16
END SUB

SUB opand8
	res8 = (oper1b AND oper2b)
	flaglog8 res8
END SUB

SUB opcmp16
	flagsub16 oper1, oper2
END SUB

SUB opcmp8
	flagsub8 oper1b, oper2b
END SUB

SUB opdiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
		IF divisor = 0 THEN intcall86 0: EXIT SUB
		IF (valdiv \ divisor) > 65535 THEN intcall86 0: EXIT SUB
		putreg16 regdx, valdiv MOD divisor
		putreg16 regax, valdiv \ divisor
END SUB

SUB opdiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
		IF divisor = 0 THEN intcall86 0: EXIT SUB
		IF (valdiv \ divisor) > 255 THEN intcall86 0: EXIT SUB
		regah = valdiv MOD divisor
		regal = valdiv \ divisor
END SUB

SUB opgrp1 (word)
SELECT CASE reg
    CASE 0: 'ADD
	IF word THEN
		opadd16
	ELSE
		opadd8
	END IF
    CASE 1: 'OR
	IF word THEN
		opor16
	ELSE
		opor8
	END IF
    CASE 2: 'ADC
	IF word THEN
		opadc16
	ELSE
		opadc8
	END IF
    CASE 3: 'SBB
	IF word THEN
		opsbb16
		 ELSE
		 opsbb8
	END IF
    CASE 4: 'AND
	IF word THEN
		opand16
		 ELSE
		 opand8
	END IF
    CASE 5: 'SUB
	IF word THEN
		opsub16
	ELSE
		opsub8
	END IF
    CASE 6: 'XOR
	IF word THEN
		opxor16
	ELSE
		opxor8
	END IF
    CASE 7: 'CMP
	IF word THEN
		opcmp16
	ELSE
		opcmp8
	END IF
END SELECT
END SUB

FUNCTION opgrp216& (BYVAL cnt AS LONG)
	DIM d, s, oldcf, shiftnum, msb AS LONG
	s = oper1 AND 65535
	oldcf = cf
	SELECT CASE reg
		     CASE 0 'ROL r/m16
			FOR Shift = 1 TO cnt
			    IF (s AND &H8000&) THEN cf = 1 ELSE cf = 0
			    s = shl(s, 1) AND &HFFFF&
			    s = s OR cf
			NEXT Shift
			IF cnt = 1 THEN
			    of = cf XOR shr(s, 15)
			END IF

		    CASE 1 'ROR r/m16
			FOR Shift = 1 TO cnt
			    cf = s AND 1
			    s = shr(s, 1) OR shl(cf, 15)
			NEXT Shift
			IF cnt = 1 THEN
			    of = shr(s, 15) XOR (shr(s, 14) AND 1)
			END IF
			
		     CASE 2 'RCL r/m16
			FOR Shift = 1 TO cnt
			    oldcf = cf
			    IF (s AND &H8000&) THEN cf = 1 ELSE cf = 0
			    s = shl(s, 1) AND &HFFFF&
			    s = s OR oldcf
			NEXT Shift
			IF cnt = 1 THEN
			    of = cf XOR shr(s, 15)
			END IF
			
		     CASE 3 'RCR r/m16
			FOR Shift = 1 TO cnt
			    oldcf = cf
			    cf = s AND 1
			    s = shr(s, 1) OR shl(oldcf, 15)
			NEXT Shift
			IF cnt = 1 THEN
			    of = shr(s, 15) XOR (shr(s, 14) AND 1)
			END IF

		     CASE 4, 6 'SHL r/m16
			    FOR Shift = 1 TO cnt
				IF (s AND &H8000&) THEN cf = 1 ELSE cf = 0
				s = shl(s, 1) AND &HFFFF&
			    NEXT Shift
			    IF cnt = 1 THEN
				IF cf = shr(s, 15) THEN of = 0 ELSE of = 1
			    END IF
			    flagszp16 (s)
			    
		     CASE 5 'SHR r/m16
			    IF cnt = 1 THEN
				IF (s AND &H8000&) THEN of = 1 ELSE of = 0
			    END IF
			    FOR Shift = 1 TO cnt
				cf = s AND 1
				s = shr(s, 1)
			    NEXT Shift
			    flagszp16 (s)

		     CASE 7 'SAR r/m16
			    FOR Shift = 1 TO cnt
				msb = s AND &H8000&
				cf = s AND 1
				s = shr(s, 1) OR msb
			    NEXT Shift
			    of = 0
			    flagszp16 (s)
			
	END SELECT
	opgrp216 = s AND &HFFFF&
END FUNCTION

FUNCTION opgrp28& (BYVAL cnt AS LONG)
	DIM d, s AS LONG
	s = oper1b AND 255
	oldcf = cf
	SELECT CASE reg
		CASE 0 'ROL r/m8
			FOR Shift = 1 TO cnt
			    IF (s AND &H80) THEN cf = 1 ELSE cf = 0
			    s = shl(s, 1)
			    s = s OR cf
			NEXT Shift
			IF cnt = 1 THEN
			    of = shr(s, 7) XOR (shr(s, 6) AND 1)
			ELSE
			    of = 0
			END IF

		CASE 1 'ROR r/m8
			FOR Shift = 1 TO cnt
			    cf = s AND 1
			    s = shr(s, 1) OR shl(cf, 7)
			NEXT Shift
			IF cnt = 1 THEN
			    of = shr(s, 7) XOR (shr(s, 6) AND 1)
			END IF
			
		   CASE 2 'RCL r/m8
			FOR Shift = 1 TO cnt
			    oldcf = cf
			    IF (s AND &H80) THEN cf = 1 ELSE cf = 0
			    s = shl(s, 1)
			    s = s OR oldcf
			NEXT Shift
			IF cnt = 1 THEN
			    of = cf XOR (shr(s, 7) AND 1)
			END IF
			
		CASE 3 'RCR r/m8
			FOR Shift = 1 TO cnt
			    oldcf = cf
			    cf = s AND 1
			    s = shr(s, 1) OR shl(oldcf, 7)
			NEXT Shift
			IF cnt = 1 THEN
			    of = shr(s, 7) XOR (shr(s, 6) AND 1)
			END IF

		     CASE 4, 6 'SHL r/m8
			    FOR Shift = 1 TO cnt
				IF (s AND &H80) THEN cf = 1 ELSE cf = 0
				s = shl(s, 1) AND &HFF&
			    NEXT Shift
			    IF cnt = 1 THEN
				IF cf = shr(s, 7) THEN of = 0 ELSE of = 1
			    END IF
			    flagszp8 (s)
			    
		     CASE 5 'SHR r/m8
			    IF cnt = 1 THEN
				IF (s AND &H80) THEN of = 1 ELSE of = 0
			    END IF
			    FOR Shift = 1 TO cnt
				cf = s AND 1
				s = shr(s, 1)
			    NEXT Shift
			    flagszp8 (s)

		     CASE 7 'SAR r/m8
			    FOR Shift = 1 TO cnt
				msb = s AND &H80
				cf = s AND 1
				s = shr(s, 1) OR msb
			    NEXT Shift
			    of = 0
			    flagszp8 (s)
			
	END SELECT
	opgrp28 = s AND &HFF
END FUNCTION

SUB opgrp3 (BYVAL word)
DIM d1, d2, s1, s2, sign AS LONG
DIM d, s AS LONG
IF word = 0 THEN oper1 = signext(oper1b): oper2 = signext(oper2b)
SELECT CASE reg
    CASE 0, 1: 'TEST
	IF word THEN
			oper2 = getmem16(regcs, ip): StepIP (2)
			optest16
	ELSE
		oper2b = getmem8(regcs, ip): StepIP (1)
		optest8
	END IF

    CASE 2: 'NOT
	IF word THEN
			res16 = NOT oper1
	ELSE
			res8 = NOT oper1b
	END IF

    CASE 3: 'NEG
	IF word THEN
			res16 = (NOT oper1) + 1
			flagsub16 0, oper1
			IF res16 = 0 THEN cf = 0 ELSE cf = 1
	ELSE
			res8 = (NOT oper1b) + 1
			flagsub8 0, oper1b
			IF res8 = 0 THEN cf = 0 ELSE cf = 1
	END IF

    CASE 4: 'MUL
	IF word THEN
			temp1 = oper1 * getreg16(regax)
			putreg16 regax, temp1 AND &HFFFF&
			putreg16 regdx, temp1 \ 65536
			flagszp16 (temp1)
			IF getreg16(regdx) <> 0 THEN cf = 1: of = 1 ELSE cf = 0: of = 0
	ELSE
			temp1 = oper1b * regal
			regah = (temp1 \ 256&) AND 255
			regal = temp1 AND 255
			flagszp8 (temp1)
			IF regah <> 0 THEN cf = 1: of = 1 ELSE cf = 0: of = 0
	END IF
	zf = 0 '8086/8088 clears ZF on multiply. if this is removed, most apps think the CPU is a NEC V20

    CASE 5: 'IMUL
	IF word THEN
	    temp1 = getreg16(regax)
	    temp2 = oper1
	    IF (temp1 AND &H8000&) = &H8000& THEN temp1 = temp1 OR &HFFFF0000
	    IF (temp2 AND &H8000&) = &H8000& THEN temp2 = temp2 OR &HFFFF0000
	    temp3 = (temp1 * temp2) AND &HFFFFFFFF
	    regah = (temp3 \ 256&) AND 255
	    regal = temp3 AND 255
	    regdh = (temp3 \ 16777216) AND 255
	    regdl = (temp3 \ 65536) AND 255
	    IF getreg16(regdx) <> 0 THEN cf = 1: of = 1 ELSE cf = 0: of = 0
	ELSE
	    oper1 = signext(oper1b)
	    temp1 = signext(regal)
	    temp2 = oper1
	    IF (temp1 AND &H80&) = &H80& THEN temp1 = temp1 OR &HFFFFFF00
	    IF (temp2 AND &H80&) = &H80& THEN temp2 = temp2 OR &HFFFFFF00
	    temp3 = (temp1 * temp2) AND &HFFFF&
	    regah = temp3 \ 256&
	    regal = temp3 AND 255
	    IF regah <> 0 THEN cf = 1: of = 1 ELSE cf = 0: of = 0
	END IF
	zf = 0 '8086/8088 clears ZF on multiply. if this is removed, most apps think the CPU is a NEC V20

    CASE 6: 'DIV
	  IF word THEN opdiv16 (getreg16(regdx) * 65536) OR getreg16(regax), oper1 ELSE opdiv8 getreg16(regax), oper1

    CASE 7: 'IDIV
	  IF word THEN opidiv16 (getreg16(regdx) * 65536) OR getreg16(regax), oper1 ELSE opidiv8 getreg16(regax), oper1
END SELECT
END SUB

SUB opgrp5
DIM tempcf AS LONG
SELECT CASE reg
    CASE 0 'INC Ev
	oper2 = 1
	tempcf = cf
	opadd16
	cf = tempcf
	writerm16 rm, res16

    CASE 1 'DEC Ev
	oper2 = 1
	tempcf = cf
	opsub16
	cf = tempcf
	writerm16 rm, res16

    CASE 2 'CALL Ev
	push ip
	ip = oper1

    CASE 3 'CALL Mp
	push regcs: push ip
	getea (rm)
	ip = read86(ea) + read86(ea + 1) * 256&
	regcs = read86(ea + 2) + read86(ea + 3) * 256&

    CASE 4 'JMP Ev
	ip = oper1

    CASE 5 'JMP Mp
	getea (rm)
	ip = read86(ea) + read86(ea + 1) * 256&
	regcs = read86(ea + 2) + read86(ea + 3) * 256&

    CASE 6 'PUSH Ev
	push oper1
END SELECT
END SUB

SUB opidiv16 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
	DIM s1, s2, d1, d2, sign AS LONG
	IF divisor = 0 THEN intcall86 0: EXIT SUB
	s1 = valdiv
	s2 = divisor
	sign = (s1 XOR s2) AND &H80000000
	IF (s1 AND &H80000000) THEN s1 = ((NOT s1) + 1) AND &HFFFFFFFF
	IF (s2 AND &H80000000) THEN s2 = ((NOT s2) + 1) AND &HFFFFFFFF
	d1 = s1 \ s2
	d2 = s1 MOD s2
	IF d1 > &HFFFF& THEN intcall86 0: EXIT SUB 'divide overflow
	IF sign <> 0 THEN
	    d1 = ((NOT d1) + 1) AND &HFF&
	    d2 = ((NOT d2) + 1) AND &HFF&
	END IF
	putreg16 regax, d1
	putreg16 regdx, d2
END SUB

SUB opidiv8 (BYVAL valdiv AS LONG, BYVAL divisor AS LONG)
	DIM s1, s2, d1, d2, sign AS LONG
	IF divisor = 0 THEN intcall86 0: EXIT SUB
	s1 = valdiv
	s2 = divisor
	sign = (s1 XOR s2) AND &H8000&
	IF s1 > &H7FFF& THEN s1 = ((NOT s1) + 1) AND &HFFFF&
	IF s2 > &H7FFF& THEN s2 = ((NOT s2) + 1) AND &HFFFF&
	d1 = s1 \ s2
	d2 = s1 MOD s2
	IF d1 > &HFF& THEN intcall86 0: EXIT SUB 'divide overflow
	IF sign <> 0 THEN
	    d1 = ((NOT d1) + 1) AND &HFF&
	    d2 = ((NOT d2) + 1) AND &HFF&
	END IF
	regal = d1
	regah = d2
END SUB

SUB opor16
	res16 = (oper1 OR oper2)
	flaglog16 res16
END SUB

SUB opor8
	res8 = (oper1b OR oper2b)
	flaglog8 res8
END SUB

SUB opsbb16
	res16 = (oper1 - oper2 - cf)
	flagsbb16 oper1, oper2, cf
END SUB

SUB opsbb8
	res8 = (oper1b - oper2b - cf)
	flagsbb8 oper1b, oper2b, cf
END SUB

SUB opsub16
	res16 = (oper1 - oper2)
	flagsub16 oper1, oper2
END SUB

SUB opsub8
	res8 = (oper1b - oper2b)
	flagsub8 oper1b, oper2b
END SUB

SUB optest16
	flaglog16 (oper1 AND oper2)
END SUB

SUB optest8
	flaglog8 (oper1b AND oper2b)
END SUB

SUB opxor16
	res16 = (oper1 XOR oper2)
	flaglog16 res16
END SUB

SUB opxor8
	res8 = (oper1b XOR oper2b)
	flaglog8 res8
END SUB

SUB out8259 (BYVAL portnum AS LONG, BYVAL value AS LONG)
    DIM i AS LONG
    SELECT CASE (portnum AND 1)
	CASE 0
	    IF (value AND &H10) THEN 'begin initialization sequence
		i8259.icwstep = 1
		i8259.imr = 0
		i8259.icw(i8259.icwstep) = value
		i8259.icwstep = i8259.icwstep + 1
		EXIT SUB
	    END IF
	    IF (value AND &H98&) = 8 THEN 'it's an OCW3
		IF (value AND 2) = 2 THEN i8259.readmode = value AND 2
	    END IF
	    IF (value AND &H20) THEN 'EOI command
		keyboardwaitack = 0
		FOR i = 0 TO 7
		    IF (shr(i8259.isr, i) AND 1) THEN
			i8259.isr = i8259.isr XOR shl(1, i)
		    END IF
		NEXT i
	    END IF
	
	CASE 1
	    IF (i8259.icwstep = 3) AND (i8259.icw(1) AND 2) THEN i8259.icwstep = 4
	    IF i8259.icwstep < 5 THEN
		i8259.icw(i8259.icwstep) = value AND 255
		EXIT SUB
	    END IF
	    i8259.imr = value AND 255
    END SELECT
END SUB

SUB ParityGen
	FOR n = 0 TO 255
		IF (n AND 1) THEN bitcount = 1 ELSE bitcount = 0
		IF (n AND 2) THEN bitcount = bitcount + 1
		IF (n AND 4) THEN bitcount = bitcount + 1
		IF (n AND 8) THEN bitcount = bitcount + 1
		IF (n AND 16) THEN bitcount = bitcount + 1
		IF (n AND 32) THEN bitcount = bitcount + 1
		IF (n AND 64) THEN bitcount = bitcount + 1
		IF (n AND 128) THEN bitcount = bitcount + 1
		IF (bitcount AND 1) THEN Parity(n) = 0 ELSE Parity(n) = 1
	NEXT n
END SUB

FUNCTION pop&
pop = getmem16(regss, regsp)
regsp = (regsp + 2) AND &HFFFF&
END FUNCTION

FUNCTION portin& (BYVAL portval AS LONG)
    SELECT CASE portval
	CASE &H20 TO &H21
	    portin = in8259(portval)
	CASE &H40& TO &H43&
	    'portin = in8253(portval) 'Int(Rnd * 256)
	CASE &H60 TO &H64
	    portin = portram(portval)
	CASE &H3C7& TO &H3C9&
	    portin = INP(portval)
	'CASE &H3C7& 'MCGA/VGA DAC read DAC state
	'    portin = statedac
	'CASE &H3C8& 'MCGA/VGA DAC palette index
	'    portin = latchreadpal
	'CASE &H3C9& 'MCGA/VGA DAC palette data
	'    SELECT CASE latchreadrgb
	'        CASE 0 'red
	'            portin = PaletteVGA(latchreadpal) AND 63
	'        CASE 1 'green
	'            portin = (PaletteVGA(latchreadpal) \ 256&) AND 63
	'        CASE 2 'blue
	'            portin = (PaletteVGA(latchreadpal) \ 65536) AND 63
	'            latchreadpal = (latchreadpal + 1) AND 255
	'    END SELECT
	'    latchreadrgb = (latchreadrgb + 1) MOD 3
	CASE &H3DA& 'video controller status reg
	    portin = INT(RND * 256) 'portram(&H3DA)
	CASE &H3D4& 'CGA/VGA CRTC register select index
	    portin = portram(&H3D4&)
	CASE &H3D5& 'CGA/VGA CRTC register data
	    portin = CRTC(portram(&H3D4&) AND 255)
	CASE &H3D9&
	    portin = INP(&H3D9&)
	CASE &H3F8 TO &H3FF 'COM1
	    portin = INP(portval)
	CASE &H388, &H389 'Adlib pass-through
	    portin = INP(portval)
	CASE ELSE
	    portin = &H80&
    END SELECT
    'IF (portval >= &H3C7&) AND (portval <= &H3C9&) THEN portin = INP(portval)
    'IF mode13h = 1 THEN
    'IF (portval >= &H3B4&) AND (portval <= &H3D5&) THEN 'OUT portval, value
    '  PRINT #3, "portin " + HEX$(portval) + ": " + HEX$(value)
    '  portin = INP(portval)
    'END IF
    'END IF
END FUNCTION

SUB portout (BYVAL portval AS LONG, BYVAL value AS LONG)
    portval = portval AND &HFFFF&
    IF portval < 4096 THEN portram(portval) = value AND &HFF&
    SELECT CASE portval
	CASE &H20 TO &H21
	    out8259 portnum, value
	CASE &H40 TO &H43
	    'out8253 portval, value
	CASE &H61
	    'If keyboardwaitack = 0 Then
	    IF (value AND 3) = 3 THEN speakerenabled = 1 ELSE speakerenabled = 0
	    'MsgBox "write port 61h, speakerenabled = " + Str$(speakerenabled)
	    'End If
	CASE &H3C7& TO &H3C9&
	    OUT portval, value
	'CASE &H3C7& 'MCGA/VGA DAC read palette index
	'    latchreadpal = value AND 255
	'    latchreadrgb = 0
	'    statedac = 0
	'CASE &H3C8& 'MCGA/VGA DAC palette index
	'    latchpal = value AND 255
	'    latchrgb = 0
	'    temprgb = 0
	'    statedac = 3
	'CASE &H3C9& 'MCGA/VGA DAC palette data
	'    value = (value AND 63) * 4
	'    SELECT CASE latchrgb
	'        CASE 0 'red
	'            tempr = value
	'        CASE 1 'green
	'            tempg = value
	'        CASE 2 'blue
	'            tempb = value
	'            PaletteVGA(latchpal) = tempr + tempg * 256& + tempb * 65536
	'            IF mode13h = 1 THEN PALETTE latchpal, PaletteVGA(latchpal)
	'            'PRINT "Palette" + STR$(latchpal) + " set"
	'            latchpal = (latchpal + 1) AND 255
	'    END SELECT
	'    latchrgb = (latchrgb + 1) MOD 3
	CASE &H3D4& 'CGA/VGA CRTC register select index
	    portram(&H3D4&) = value AND 255
	CASE &H3D5& 'CGA/VGA CRTC register data
	    CRTC(portram(&H3D4&) AND 255) = value AND 255
	    SELECT CASE (portram(&H3D4&) AND 255)
		CASE &HA, &HE, &HF
		    temp32 = ((CRTC(&HE) AND &H3F) * 256) + (CRTC(&HF) AND 255)
		    cursx = temp32 MOD cols
		    cursy = temp32 \ cols
		    IF cursy > 24 THEN cursy = 24
		    IF cursx > 79 THEN cursx = 79
		    LOCATE cursy + 1, cursx + 1, 1
	    END SELECT
	CASE &H3D9&
	    OUT &H3D9, value
	    IF cgagfx = 1 THEN COLOR 0, (value \ &H20&) AND 1
	CASE &H3F8 TO &H3FF 'COM1
	    OUT portval, value
	CASE &H388, &H389 'Adlib pass-through
	    OUT portval, value
    END SELECT
    'IF mode13h = 1 THEN
    'IF (portval >= &H3B4&) AND (portval <= &H3DA&) THEN 'OUT portval, value
    '  PRINT #3, "portout " + HEX$(portval) + ": " + HEX$(value)
    '  OUT portval, value
    'END IF
    'END IF
END SUB

SUB push (BYVAL pushval AS LONG)
regsp = (regsp - 2) AND &HFFFF&
putmem16 regss, regsp, pushval
END SUB

SUB putmem16 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
	write86 segment * 16 + offset, value AND &HFF
	write86 segment * 16 + offset + 1, value \ 256&
END SUB

SUB putmem8 (BYVAL segment AS LONG, BYVAL offset AS LONG, BYVAL value AS LONG)
	write86 segment * 16 + offset, value
END SUB

SUB putreg16 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DIM value1 AS LONG
value1 = value AND &HFFFF&
SELECT CASE regnum
	CASE regax
	regal = value1 AND 255: regah = value1 \ 256&
    CASE regcx
	regcl = value1 AND 255: regch = value1 \ 256&
	CASE regdx
	regdl = value1 AND 255: regdh = value1 \ 256&
    CASE regbx
	regbl = value1 AND 255: regbh = value1 \ 256&
	CASE 4: regsp = value1
	CASE 5: regbp = value1
	CASE 6: regsi = value1
	CASE 7: regdi = value1
END SELECT
END SUB

SUB putreg8 (BYVAL regnum AS LONG, BYVAL value AS LONG)
DIM value1 AS LONG
value1 = value AND &HFF&
SELECT CASE regnum
	CASE 0: regal = value1
	CASE 1: regcl = value1
	CASE 2: regdl = value1
	CASE 3: regbl = value1
	CASE 4: regah = value1
	CASE 5: regch = value1
	CASE 6: regdh = value1
	CASE 7: regbh = value1
END SELECT
END SUB

SUB putsegreg (BYVAL regnum AS LONG, BYVAL value AS LONG)
SELECT CASE regnum
    CASE 0
	reges = value AND &HFFFF&
    CASE 1
	regcs = value AND &HFFFF&
    CASE 2
	regss = value AND &HFFFF&
    CASE 3
	regds = value AND &HFFFF&
END SELECT
END SUB

FUNCTION read86& (BYVAL addr32 AS LONG)
addr32 = addr32 AND &HFFFFF
'DIM rambyte AS STRING * 1

SELECT CASE addr32
       CASE &H410&
	read86 = &H41& '&H41 for VGA
	EXIT FUNCTION
	CASE &H475&
	read86 = hdcount
       EXIT FUNCTION
       CASE &HA0000 TO &HAFFFF
	 DEF SEG = &HA000
	 read86 = PEEK(addr32 - &HA0000)
	 'DEF SEG = VARSEG(ramchunk)
       CASE &HB0000 TO &HBFFFF
	 DEF SEG = &HB000
	 read86 = PEEK(addr32 - &HB0000)
	 'DEF SEG = VARSEG(ramchunk)
       CASE &HC0000 TO &HC7FFF
	addr32 = addr32 - &HC0000
	DEF SEG = VBIOS(addr32 \ 1024&)
	read86 = PEEK(addr32 AND 1023&)
       CASE IS >= &HFE000
	  read86 = BIOS(addr32 AND &H1FFF&)
       CASE IS < 376832
	   DEF SEG = ramseg(addr32 \ 1024&)
	   read86 = PEEK(addr32 AND 1023&)
       CASE 376832 TO 655359 'disk swap
	 IF addr32 >= ramlimit THEN EXIT FUNCTION
	 addr32 = addr32 - 376832
	 needswap = addr32 \ 1024&
	 IF needswap <> swapcur THEN
	   IF swapcur > -1 THEN
	     SEEK #2, swapcur * 1024& + 1
	     PUT #2, , swapram
	   END IF
	   SEEK #2, needswap * 1024& + 1
	   GET #2, , swapram
	   swapcur = needswap
	 END IF
	 DEF SEG = VARSEG(swapram)
	 read86 = PEEK(VARPTR(swapram) + (addr32 AND 1023&))
END SELECT
END FUNCTION

SUB ReadDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
DIM lba, MemDest AS LONG
DIM cursect, curpos, goodsects AS LONG
ON ERROR RESUME NEXT
lba = ((Cyl * Disk(DriveNum).Heads * Disk(DriveNum).Sectors) + (Head * Disk(DriveNum).Sectors) + Sect - 1) * 512&
'LOCATE 23, 1
'PRINT "Cylinder:" + STR$(Cyl) + " Head:" + STR$(Head) + " Sector: " + STR$(Sect) + " Sector count:" + STR$(SectCount) + " @ " + HEX$(DstSeg) + ":" + HEX$(DstOff) + "  ";
MemDest = DstSeg * 16& + DstOff
IF TraceLog = 1 THEN PRINT #2, "Sector" + STR$(lba \ 512) + " read:" + STR$(regal) + " sectors into " + HEX$(reges) + ":" + HEX$(getreg16(regbx))
SEEK DriveNum + 5, lba + 1
'MsgBox "LOC:" + Str$(Loc(DriveNum + 5))
'MsgBox Hex$(MemDest)
FOR cursect = 1 TO SectCount
    GET DriveNum + 5, , SectorBuffer
    FOR curpos = 1 TO 512
	'Get DriveNum + 5, , RAM(MemDest)
	write86 MemDest, ASC(MID$(SectorBuffer, curpos, 1))
	MemDest = MemDest + 1
    NEXT curpos
    IF ERR <> 0 THEN EXIT FOR
    goodsects = goodsects + 1
NEXT cursect
IF ERR <> 0 THEN
    cf = 1: regah = 4
    regal = goodsects
ELSE
    cf = 0: regah = 0
END IF
END SUB

FUNCTION readrm16& (BYVAL rmval AS INTEGER)
	IF mode < 3 THEN
		getea (rmval)
		readrm16 = read86(ea) + read86(ea + 1) * 256&
	ELSE
		readrm16 = getreg16(rmval)
	END IF
END FUNCTION

FUNCTION readrm8& (BYVAL rmval AS INTEGER)
	IF mode < 3 THEN
		getea (rmval)
		readrm8 = read86(ea)
	ELSE
		readrm8 = getreg8(rmval) AND 255
	END IF
END FUNCTION

SUB reset86
regax = 0
regcx = 1
regdx = 2
regbx = 3
hltstate = 0
regcs = &HFFFF&
ip = &H0
StartedYet = 1
END SUB

FUNCTION shl& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
src = src AND &HFFFF&
shl = src * (2 ^ bitcount)
END FUNCTION

FUNCTION shr& (BYVAL src AS LONG, BYVAL bitcount AS LONG)
src = src AND &HFFFF&
shr = src \ (2 ^ bitcount)
END FUNCTION

FUNCTION signext& (BYVAL value AS INTEGER)
	IF (value AND &H80&) THEN signext = &HFF00& + value ELSE signext = value
	'If value > 127 Then signext = (value - 256) And &HFFFF& Else signext = value And &HFFF&
END FUNCTION

SUB StepIP (BYVAL stepcount AS LONG)
	ip = ip + stepcount
END SUB

SUB write86 (BYVAL addr32 AS LONG, BYVAL value AS LONG)
DIM rambyte AS STRING * 1
	addr32 = addr32 AND &HFFFFF
	'IF ReadOnly(addr32) THEN EXIT SUB
	SELECT CASE addr32
	    CASE &HA0000 TO &HAFFFF
		'UpdatedScreen = 1
		DEF SEG = &HA000
		POKE addr32 - &HA0000, value
		'DEF SEG = VARSEG(ramchunk)
	    CASE &HB0000 TO &HBFFFF
		'UpdatedScreen = 1
		DEF SEG = &HB000
		POKE addr32 - &HB0000, value
	    CASE IS < 376832
	      DEF SEG = ramseg(addr32 \ 1024&)
	      POKE addr32 AND 1023&, value
       CASE 376832 TO 655359 'disk swap
	 IF addr32 >= ramlimit THEN EXIT SUB
	 addr32 = addr32 - 376832
	 needswap = addr32 \ 1024&
	 IF needswap <> swapcur THEN
	   IF swapcur > -1 THEN
	     SEEK #2, swapcur * 1024& + 1
	     PUT #2, , swapram
	   END IF
	   SEEK #2, needswap * 1024& + 1
	   GET #2, , swapram
	   swapcur = needswap
	 END IF
	 DEF SEG = VARSEG(swapram)
	 POKE VARPTR(swapram) + (addr32 AND 1023&), value
	END SELECT
END SUB

SUB WriteDisk (BYVAL DriveNum AS LONG, BYVAL DstSeg AS LONG, BYVAL DstOff AS LONG, BYVAL Cyl AS LONG, BYVAL Sect AS LONG, BYVAL Head AS LONG, BYVAL SectCount AS LONG)
DIM lba, MemDest AS LONG
DIM cursect, curpos, goodsects AS LONG
ON ERROR RESUME NEXT
lba = ((Cyl * Disk(DriveNum).Heads * Disk(DriveNum).Sectors) + (Head * Disk(DriveNum).Sectors) + Sect - 1) * 512&
MemDest = DstSeg * 16& + DstOff
SEEK DriveNum + 5, lba + 1
FOR cursect = 1 TO SectCount
    tempout$ = ""
    FOR curpos = 0 TO 511
	tempout$ = tempout$ + CHR$(read86(MemDest) AND 255)
	MemDest = MemDest + 1&
    NEXT curpos
    PUT DriveNum + 5, , tempout$
    IF ERR <> 0 THEN EXIT FOR
    goodsects = goodsects + 1
NEXT cursect
IF ERR <> 0 THEN
    cf = 1: regah = 4
    regal = goodsects
ELSE
    cf = 0: regah = 0
END IF
END SUB

SUB writerm16 (BYVAL rmval AS LONG, BYVAL value AS LONG)
	DIM value1 AS LONG
	value1 = (value) AND 65535
	IF mode < 3 THEN
		getea (rmval)
		write86 ea, value1 AND &HFF
		write86 ea + 1, value1 \ 256&
	ELSE
		putreg16 rmval, value1
	END IF
END SUB

SUB writerm8 (BYVAL rmval AS LONG, BYVAL value AS LONG)
	DIM value1 AS LONG
	value1 = (value) AND 255
	IF mode < 3 THEN
		getea (rmval)
		write86 ea, value1
	ELSE
		putreg8 rmval, value1
	END IF
END SUB

